	even

old_int_9	dd	0	;Old INT 9 offset + segment
old_int_8	dd	0	;Old INT 8 offset + segment

;
;Some address pointer tables
;
rom_file_errors:	dw	rom_error_open
	dw	rom_error_size
	dw	rom_error_read

sam_file_errors:	dw	sam_error_open
	dw	sam_error_size
	dw	sam_error_read

init_e_tab:	dw	wrong_dsp
	dw	init_fail

;
;Opcode word table, used to index to the psuedo 6502 instruction handlers
;
opcode_6502:	dw	op_00,op_01,crash,crash,crash,op_05,op_06,crash
	dw	op_08,op_09,op_0A,crash,crash,op_0D,op_0E,crash
	dw	op_10,op_11,crash,crash,crash,op_15,op_16,crash
	dw	op_18,op_19,crash,crash,crash,op_1D,op_1E,crash
	dw	op_20,op_21,crash,crash,op_24,op_25,op_26,crash
	dw	op_28,op_29,op_2A,crash,op_2C,op_2D,op_2E,crash
	dw	op_30,op_31,crash,crash,crash,op_35,op_36,crash
	dw	op_38,op_39,crash,crash,crash,op_3D,op_3E,crash
	dw	op_40,op_41,crash,crash,crash,op_45,op_46,crash
	dw	op_48,op_49,op_4A,crash,op_4C,op_4D,op_4E,crash
	dw	op_50,op_51,crash,crash,crash,op_55,op_56,crash
	dw	op_58,op_59,crash,crash,crash,op_5D,op_5E,crash
	dw	op_60,op_61,crash,crash,crash,op_65,op_66,crash
	dw	op_68,op_69,op_6A,crash,op_6C,op_6D,op_6E,crash
	dw	op_70,op_71,crash,crash,crash,op_75,op_76,crash
	dw	op_78,op_79,crash,crash,crash,op_7D,op_7E,crash
	dw	crash,op_81,crash,crash,op_84,op_85,op_86,crash
	dw	op_88,crash,op_8A,crash,op_8C,op_8D,op_8E,crash
	dw	op_90,op_91,crash,crash,op_94,op_95,op_96,crash
	dw	op_98,op_99,op_9A,crash,crash,op_9D,crash,crash
	dw	op_A0,op_A1,op_A2,crash,op_A4,op_A5,op_A6,crash
	dw	op_A8,op_A9,op_AA,crash,op_AC,op_AD,op_AE,crash
	dw	op_B0,op_B1,crash,crash,op_B4,op_B5,op_B6,crash
	dw	op_B8,op_B9,op_BA,crash,op_BC,op_BD,op_BE,crash
	dw	op_C0,op_C1,crash,crash,op_C4,op_C5,op_C6,crash
	dw	op_C8,op_C9,op_CA,crash,op_CC,op_CD,op_CE,crash
	dw	op_D0,op_D1,crash,crash,crash,op_D5,op_D6,crash
	dw	op_D8,op_D9,crash,crash,crash,op_DD,op_DE,crash
	dw	op_E0,op_E1,crash,crash,op_E4,op_E5,op_E6,crash
	dw	op_E8,op_E9,op_EA,crash,op_EC,op_ED,op_EE,crash
	dw	op_F0,op_F1,crash,crash,crash,op_F5,op_F6,crash
	dw	op_F8,op_F9,crash,crash,crash,op_FD,op_FE,crash

seg_6502	dw	0	;Holds segment of virtual 6502
draw_seg	dw	0	;Holds segment of draw lists

;
;Allows faster calculations of the Y screen coordinate than mult/shifting
;
y_table	dw	 0 
	dw	 80 
	dw	 160 
	dw	 240 
	dw	 320 
	dw	 400 
	dw	 480 
	dw	 560 
	dw	 640 
	dw	 720 
	dw	 800 
	dw	 880 
	dw	 960 
	dw	 1040 
	dw	 1120 
	dw	 1200 
	dw	 1280 
	dw	 1360 
	dw	 1440 
	dw	 1520 
	dw	 1600 
	dw	 1680 
	dw	 1760 
	dw	 1840 
	dw	 1920 
	dw	 2000 
	dw	 2080 
	dw	 2160 
	dw	 2240 
	dw	 2320 
	dw	 2400 
	dw	 2480 
	dw	 2560 
	dw	 2640 
	dw	 2720 
	dw	 2800 
	dw	 2880 
	dw	 2960 
	dw	 3040 
	dw	 3120 
	dw	 3200 
	dw	 3280 
	dw	 3360 
	dw	 3440 
	dw	 3520 
	dw	 3600 
	dw	 3680 
	dw	 3760 
	dw	 3840 
	dw	 3920 
	dw	 4000 
	dw	 4080 
	dw	 4160 
	dw	 4240 
	dw	 4320 
	dw	 4400 
	dw	 4480 
	dw	 4560 
	dw	 4640 
	dw	 4720 
	dw	 4800 
	dw	 4880 
	dw	 4960 
	dw	 5040 
	dw	 5120 
	dw	 5200 
	dw	 5280 
	dw	 5360 
	dw	 5440 
	dw	 5520 
	dw	 5600 
	dw	 5680 
	dw	 5760 
	dw	 5840 
	dw	 5920 
	dw	 6000 
	dw	 6080 
	dw	 6160 
	dw	 6240 
	dw	 6320 
	dw	 6400 
	dw	 6480 
	dw	 6560 
	dw	 6640 
	dw	 6720 
	dw	 6800 
	dw	 6880 
	dw	 6960 
	dw	 7040 
	dw	 7120 
	dw	 7200 
	dw	 7280 
	dw	 7360 
	dw	 7440 
	dw	 7520 
	dw	 7600 
	dw	 7680 
	dw	 7760 
	dw	 7840 
	dw	 7920 
	dw	 8000 
	dw	 8080 
	dw	 8160 
	dw	 8240 
	dw	 8320 
	dw	 8400 
	dw	 8480 
	dw	 8560 
	dw	 8640 
	dw	 8720 
	dw	 8800 
	dw	 8880 
	dw	 8960 
	dw	 9040 
	dw	 9120 
	dw	 9200 
	dw	 9280 
	dw	 9360 
	dw	 9440 
	dw	 9520 
	dw	 9600 
	dw	 9680 
	dw	 9760 
	dw	 9840 
	dw	 9920 
	dw	 10000 
	dw	 10080 
	dw	 10160 
	dw	 10240 
	dw	 10320 
	dw	 10400 
	dw	 10480 
	dw	 10560 
	dw	 10640 
	dw	 10720 
	dw	 10800 
	dw	 10880 
	dw	 10960 
	dw	 11040 
	dw	 11120 
	dw	 11200 
	dw	 11280 
	dw	 11360 
	dw	 11440 
	dw	 11520 
	dw	 11600 
	dw	 11680 
	dw	 11760 
	dw	 11840 
	dw	 11920 
	dw	 12000 
	dw	 12080 
	dw	 12160 
	dw	 12240 
	dw	 12320 
	dw	 12400 
	dw	 12480 
	dw	 12560 
	dw	 12640 
	dw	 12720 
	dw	 12800 
	dw	 12880 
	dw	 12960 
	dw	 13040 
	dw	 13120 
	dw	 13200 
	dw	 13280 
	dw	 13360 
	dw	 13440 
	dw	 13520 
	dw	 13600 
	dw	 13680 
	dw	 13760 
	dw	 13840 
	dw	 13920 
	dw	 14000 
	dw	 14080 
	dw	 14160 
	dw	 14240 
	dw	 14320 
	dw	 14400 
	dw	 14480 
	dw	 14560 
	dw	 14640 
	dw	 14720 
	dw	 14800 
	dw	 14880 
	dw	 14960 
	dw	 15040 
	dw	 15120 
	dw	 15200 
	dw	 15280 
	dw	 15360 
	dw	 15440 
	dw	 15520 
	dw	 15600 
	dw	 15680 
	dw	 15760 
	dw	 15840 
	dw	 15920 
	dw	 16000 
	dw	 16080 
	dw	 16160 
	dw	 16240 
	dw	 16320 
	dw	 16400 
	dw	 16480 
	dw	 16560 
	dw	 16640 
	dw	 16720 
	dw	 16800 
	dw	 16880 
	dw	 16960 
	dw	 17040 
	dw	 17120 
	dw	 17200 
	dw	 17280 
	dw	 17360 
	dw	 17440 
	dw	 17520 
	dw	 17600 
	dw	 17680 
	dw	 17760 
	dw	 17840 
	dw	 17920 
	dw	 18000 
	dw	 18080 
	dw	 18160 
	dw	 18240 
	dw	 18320 
	dw	 18400 
	dw	 18480 
	dw	 18560 
	dw	 18640 
	dw	 18720 
	dw	 18800 
	dw	 18880 
	dw	 18960 
	dw	 19040 
	dw	 19120 
	dw	 19200 
	dw	 19280 
	dw	 19360 
	dw	 19440 
	dw	 19520 
	dw	 19600 
	dw	 19680 
	dw	 19760 
	dw	 19840 
	dw	 19920 
	dw	 20000 
	dw	 20080 
	dw	 20160 
	dw	 20240 
	dw	 20320 
	dw	 20400 
	dw	 20480 
	dw	 20560 
	dw	 20640 
	dw	 20720 
	dw	 20800 
	dw	 20880 
	dw	 20960 
	dw	 21040 
	dw	 21120 
	dw	 21200 
	dw	 21280 
	dw	 21360 
	dw	 21440 
	dw	 21520 
	dw	 21600 
	dw	 21680 
	dw	 21760 
	dw	 21840 
	dw	 21920 
	dw	 22000 
	dw	 22080 
	dw	 22160 
	dw	 22240 
	dw	 22320 
	dw	 22400 
	dw	 22480 
	dw	 22560 
	dw	 22640 
	dw	 22720 
	dw	 22800 
	dw	 22880 
	dw	 22960 
	dw	 23040 
	dw	 23120 
	dw	 23200 
	dw	 23280 
	dw	 23360 
	dw	 23440 
	dw	 23520 
	dw	 23600 
	dw	 23680 
	dw	 23760 
	dw	 23840 
	dw	 23920 
	dw	 24000 
	dw	 24080 
	dw	 24160 
	dw	 24240 
	dw	 24320 
	dw	 24400 
	dw	 24480 
	dw	 24560 
	dw	 24640 
	dw	 24720 
	dw	 24800 
	dw	 24880 
	dw	 24960 
	dw	 25040 
	dw	 25120 
	dw	 25200 
	dw	 25280 
	dw	 25360 
	dw	 25440 
	dw	 25520 
	dw	 25600 
	dw	 25680 
	dw	 25760 
	dw	 25840 
	dw	 25920 
	dw	 26000 
	dw	 26080 
	dw	 26160 
	dw	 26240 
	dw	 26320 
	dw	 26400 
	dw	 26480 
	dw	 26560 
	dw	 26640 
	dw	 26720 
	dw	 26800 
	dw	 26880 
	dw	 26960 
	dw	 27040 
	dw	 27120 
	dw	 27200 
	dw	 27280 
	dw	 27360 
	dw	 27440 
	dw	 27520 
	dw	 27600 
	dw	 27680 
	dw	 27760 
	dw	 27840 
	dw	 27920 
	dw	 28000 
	dw	 28080 
	dw	 28160 
	dw	 28240 
	dw	 28320 
	dw	 28400 
	dw	 28480 
	dw	 28560 
	dw	 28640 
	dw	 28720 
	dw	 28800 
	dw	 28880 
	dw	 28960 
	dw	 29040 
	dw	 29120 
	dw	 29200 
	dw	 29280 
	dw	 29360 
	dw	 29440 
	dw	 29520 
	dw	 29600 
	dw	 29680 
	dw	 29760 
	dw	 29840 
	dw	 29920 
	dw	 30000 
	dw	 30080 
	dw	 30160 
	dw	 30240 
	dw	 30320 
	dw	 30400 
	dw	 30480 
	dw	 30560 
	dw	 30640 
	dw	 30720 
	dw	 30800 
	dw	 30880 
	dw	 30960 
	dw	 31040 
	dw	 31120 
	dw	 31200 
	dw	 31280 
	dw	 31360 
	dw	 31440 
	dw	 31520 
	dw	 31600 
	dw	 31680 
	dw	 31760 
	dw	 31840 
	dw	 31920 
	dw	 32000 
	dw	 32080 
	dw	 32160 
	dw	 32240 
	dw	 32320 
	dw	 32400 
	dw	 32480 
	dw	 32560 
	dw	 32640 
	dw	 32720 
	dw	 32800 
	dw	 32880 
	dw	 32960 
	dw	 33040 
	dw	 33120 
	dw	 33200 
	dw	 33280 
	dw	 33360 
	dw	 33440 
	dw	 33520 
	dw	 33600 
	dw	 33680 
	dw	 33760 
	dw	 33840 
	dw	 33920 
	dw	 34000 
	dw	 34080 
	dw	 34160 
	dw	 34240 
	dw	 34320 
	dw	 34400 
	dw	 34480 
	dw	 34560 
	dw	 34640 
	dw	 34720 
	dw	 34800 
	dw	 34880 
	dw	 34960 
	dw	 35040 
	dw	 35120 
	dw	 35200 
	dw	 35280 
	dw	 35360 
	dw	 35440 
	dw	 35520 
	dw	 35600 
	dw	 35680 
	dw	 35760 
	dw	 35840 
	dw	 35920 
	dw	 36000 
	dw	 36080 
	dw	 36160 
	dw	 36240 
	dw	 36320 
	dw	 36400 
	dw	 36480 
	dw	 36560 
	dw	 36640 
	dw	 36720 
	dw	 36800 
	dw	 36880 
	dw	 36960 
	dw	 37040 
	dw	 37120 
	dw	 37200 
	dw	 37280 
	dw	 37360 
	dw	 37440 
	dw	 37520 
	dw	 37600 
	dw	 37680 
	dw	 37760 
	dw	 37840 
	dw	 37920 
	dw	 38000 
	dw	 38080 
	dw	 38160 
	dw	 38240 
	dw	 38320 

;
;General data area, loaded into current code segment
;
error2:	db	'192k of free Base Memory$'
error3:	db	'a VGA display$'

generror:	db	'Sorry, you need at least $'
generror1:	db	' to run this emulator!',13,10,'$'

rom_filename:	db	'ASTEROID.ROM',0
samples_filename:	db	'ASTEROID.SAM',0
highs_filename:	db	'ASTEROID.HI',0

abort:	db	13,10,'EMULATION ABORTED!',13,10,10,'$'

rom_error_open:	db	'Failed to open ROM file.'
	db	13,10,'$'

rom_error_size:	db	'The ROM file is the wrong size, should be 8192 '
	db	'bytes.',13,10,'$'

rom_error_read:	db	'Error reading the ROM file.',13,10,'$'

last_swap	db	0	;Holds value for 200h-300h swap
vector_state	db	0	;Holds last VECGO value
flash_count	db	0	;Flashing counter

;
;Key name tables, for the key define routines
;
scan_table:	db	k_esc-k_esc
	db	k_1-k_esc
	db	k_2-k_esc
	db	k_3-k_esc
	db	k_4-k_esc
	db	k_5-k_esc
	db	k_6-k_esc
	db	k_7-k_esc
	db	k_8-k_esc
	db	k_9-k_esc
	db	k_0-k_esc
	db	k_minus-k_esc
	db	k_equals-k_esc
	db	k_backspace-k_esc
	db	k_tab-k_esc
	db	k_q-k_esc
	db	k_w-k_esc
	db	k_e-k_esc
	db	k_r-k_esc
	db	k_t-k_esc
	db	k_y-k_esc
	db	k_u-k_esc
	db	k_i-k_esc
	db	k_o-k_esc
	db	k_p-k_esc
	db	k_open_square-k_esc
	db	k_close_square-k_esc
	db	k_return-k_esc
	db	k_control-k_esc
	db	k_a-k_esc
	db	k_s-k_esc
	db	k_d-k_esc
	db	k_f-k_esc
	db	k_g-k_esc
	db	k_h-k_esc
	db	k_j-k_esc
	db	k_k-k_esc
	db	k_l-k_esc
	db	k_semi-k_esc
	db	k_apos-k_esc
	db	k_plip-k_esc
	db	k_left_shift-k_esc
	db	k_hash-k_esc
	db	k_z-k_esc
	db	k_x-k_esc
	db	k_c-k_esc
	db	k_v-k_esc
	db	k_b-k_esc
	db	k_n-k_esc
	db	k_m-k_esc
	db	k_comma-k_esc
	db	k_dot-k_esc
	db	k_slash-k_esc
	db	k_right_shift-k_esc
	db	k_star-k_esc
	db	k_alt-k_esc
	db	k_space-k_esc
	db	k_caps-k_esc
	db	k_f1-k_esc
	db	k_f2-k_esc
	db	k_f3-k_esc
	db	k_f4-k_esc
	db	k_f5-k_esc
	db	k_f6-k_esc
	db	k_f7-k_esc
	db	k_f8-k_esc
	db	k_f9-k_esc
	db	k_f10-k_esc
	db	k_numlock-k_esc
	db	k_scroll_lock-k_esc
	db	k_home-k_esc
	db	k_up-k_esc
	db	k_pgup-k_esc
	db	k_minus-k_esc
	db	k_left-k_esc
	db	k_5-k_esc
	db	k_right-k_esc
	db	k_plus-k_esc
	db	k_end-k_esc
	db	k_down-k_esc
	db	k_pgdn-k_esc
	db	k_insert-k_esc
	db	k_del-k_esc
	db	k_null1-k_esc
	db	k_null2-k_esc
	db	k_slash2-k_esc
	db	k_f11-k_esc
	db	k_f12-k_esc
	db	k_choose-k_esc
	db	k_blank-k_esc

k_esc:	db	'E'-65+1
	db	's'-71+1
	db	'c'+128-71+1
k_1:	db	'1'+128+4+1
k_2:	db	'2'+128+4+1
k_3:	db	'3'+128+4+1
k_4:	db	'4'+128+4+1
k_5:	db	'5'+128+4+1
k_6:	db	'6'+128+4+1
k_7:	db	'7'+128+4+1
k_8:	db	'8'+128+4+1
k_9:	db	'9'+128+4+1
k_0:	db	'0'+128+4+1
k_minus:	db	76+128+1
k_equals:	db	79+128+1
k_backspace:	db	'B'-65+1
	db	'a'-71+1
	db	'c'-71+1
	db	'k'-71+1
	db	's'-71+1
	db	'p'-71+1
	db	'a'-71+1
	db	'c'-71+1
	db	'e'+128-71+1
k_tab:	db	'T'-65+1
	db	'a'-71+1
	db	'b'+128-71+1
k_q:	db	'Q'+128-65+1
k_w:	db	'W'+128-65+1
k_e:	db	'E'+128-65+1
k_r:	db	'R'+128-65+1
k_t:	db	'T'+128-65+1
k_y:	db	'Y'+128-65+1
k_u:	db	'U'+128-65+1
k_i:	db	'I'+128-65+1
k_o:	db	'O'+128-65+1
k_p:	db	'P'+128-65+1
k_open_square:	db	77+128+1
k_close_square:	db	78+128+1
k_return:	db	'E'-65+1
	db	'n'-71+1
	db	't'-71+1
	db	'e'-71+1
	db	'r'+128-71+1
k_control:	db	'C'-65+1
	db	'o'-71+1
	db	'n'-71+1
	db	't'-71+1
	db	'r'-71+1
	db	'o'-71+1
	db	'l'+128-71+1
k_a:	db	'A'+128-65+1
k_s:	db	'S'+128-65+1
k_d:	db	'D'+128-65+1
k_f:	db	'F'+128-65+1
k_g:	db	'G'+128-65+1
k_h:	db	'H'+128-65+1
k_j:	db	'J'+128-65+1
k_k:	db	'K'+128-65+1
k_l:	db	'L'+128-65+1
k_semi:	db	80+128+1
k_apos:	db	81+128+1
k_plip:	db	82+128+1
k_left_shift:	db	'L'-65+1
	db	'e'-71+1
	db	'f'-71+1
	db	't'-71+1
	db	75+1
	db	'S'-65+1
	db	'h'-71+1
	db	'i'-71+1
	db	'f'-71+1
	db	't'+128-71+1
k_z:	db	'Z'+128-65+1
k_x:	db	'X'+128-65+1
k_c:	db	'C'+128-65+1
k_v:	db	'V'+128-65+1
k_b:	db	'B'+128-65+1
k_n:	db	'N'+128-65+1
k_m:	db	'M'+128-65+1
k_comma:	db	62+128+1
k_dot:	db	63+128+1
k_slash:	db	83+128+1
k_right_shift:	db	'R'-65+1
	db	'i'-71+1
	db	'g'-71+1
	db	'h'-71+1
	db	't'-71+1
	db	75+1
	db	'S'-65+1
	db	'h'-71+1
	db	'i'-71+1
	db	'f'-71+1
	db	't'+128-71+1
k_star:	db	84+128+1
k_alt:	db	'A'-65+1
	db	'l'-71+1
	db	't'+128-71+1
k_space:	db	'S'-65+1
	db	'p'-71+1
	db	'a'-71+1
	db	'c'-71+1
	db	'e'+128-71+1
k_caps:	db	'C'-65+1
	db	'a'-71+1
	db	'p'-71+1
	db	's'-71+1
	db	75+1
	db	'L'-65+1
	db	'o'-71+1
	db	'c'-71+1
	db	'k'+128-71+1
k_f1:	db	'F'-65+1
	db	'1'+128+4+1
k_f2:	db	'F'-65+1
	db	'2'+128+4+1
k_f3:	db	'F'-65+1
	db	'3'+128+4+1
k_f4:	db	'F'-65+1
	db	'4'+128+4+1
k_f5:	db	'F'-65+1
	db	'5'+128+4+1
k_f6:	db	'F'-65+1
	db	'6'+128+4+1
k_f7:	db	'F'-65+1
	db	'7'+128+4+1
k_f8:	db	'F'-65+1
	db	'8'+128+4+1
k_f9:	db	'F'-65+1
	db	'9'+128+4+1
k_f10:	db	'F'-65+1
	db	'1'+4+1
	db	'0'+128+4+1
k_numlock:	db	'N'-65+1
	db	'u'-71+1
	db	'm'-71+1
	db	75+1
	db	'L'-65+1
	db	'o'-71+1
	db	'c'-71+1
	db	'k'+128-71+1
k_scroll_lock:	db	'S'-65+1
	db	'c'-71+1
	db	'r'-71+1
	db	'o'-71+1
	db	'l'-71+1
	db	'l'-71+1
	db	75+1
	db	'L'-65+1
	db	'o'-71+1
	db	'c'-71+1
	db	'k'+128-71+1
k_home:	db	'H'-65+1
	db	'o'-71+1
	db	'm'-71+1
	db	'e'+128-71+1
k_up:	db	'U'-65+1
	db	'p'+128-71+1
k_pgup:	db	'P'-65+1
	db	'a'-71+1
	db	'g'-71+1
	db	'e'-71+1
	db	75+1
	db	'U'-65+1
	db	'p'+128-71+1
k_left:	db	'L'-65+1
	db	'e'-71+1
	db	'f'-71+1
	db	't'+128-71+1
k_right:	db	'R'-65+1
	db	'i'-71+1
	db	'g'-71+1
	db	'h'-71+1
	db	't'+128-71+1
k_plus:	db	87+128+1
k_end:	db	'E'-65+1
	db	'n'-71+1
	db	'd'+128-71+1
k_down:	db	'D'-65+1
	db	'o'-71+1
	db	'w'-71+1
	db	'n'+128-71+1
k_pgdn:	db	'P'-65+1
	db	'a'-71+1
	db	'g'-71+1
	db	'e'-71+1
	db	75+1
	db	'D'-65+1
	db	'o'-71+1
	db	'w'-71+1
	db	'n'+128-71+1
k_insert:	db	'I'-65+1
	db	'n'-71+1
	db	's'-71+1
	db	'e'-71+1
	db	'r'-71+1
	db	't'+128-71+1
k_del:	db	'D'-65+1
	db	'e'-71+1
	db	'l'-71+1
	db	'e'-71+1
	db	't'-71+1
	db	'e'+128-71+1
k_f11:	db	'F'-65+1
	db	'1'+4+1
	db	'1'+128+4+1
k_f12:	db	'F'-65+1
	db	'1'+4+1
	db	'2'+128+4+1
k_hash:	db	85+128+1
k_null1:	db	'N'-65+1
	db	'u'-71+1
	db	'l'-71+1
	db	'l'-71+1
	db	'1'+128+4+1
k_null2:	db	'N'-65+1
	db	'u'-71+1
	db	'l'-71+1
	db	'l'-71+1
	db	'2'+128+4+1
k_slash2:	db	86+128+1

k_choose:	db	76
	db	'C'-65+1
	db	'h'-71+1
	db	'o'-71+1
	db	'o'-71+1
	db	's'-71+1
	db	'e'-71+1
	db	75+1
	db	'K'-65+1
	db	'e'-71+1
	db	'y'-71+1
	db	75+128+1

k_blank:	db	76,76,76,76,76,76,76,76,76,76,76,76+128

;
	include	text.asm	;Include scrambled text
	include	palette.asm	;Include palette data
	include font.asm	;Include font data
;
;Game highscore area, for saving highscore table
;
high_table:	db	53 dup (0)

;
;Current key defines in scancodes, plus current dipswitches
;
left_key	db	10h	;Default Q
right_key	db	11h	;Default W
thrust_key	db	26h	;Default L
fire_key	db	19h	;Default P
hyperspace_key	db	39h	;Defualt SPACE

current_dips	db	10000100b	;Default dipswitches

;
;Build addresses in labels, for the sound samples.
;
beat1	equ	$
beat2	equ	beat1+beat1_length-1
lexplode	equ	beat2+beat2_length-1
mexplode	equ	lexplode+lexplode_length-1
sexplode	equ	mexplode+mexplode_length-1
pfire	equ	sexplode+sexplode_length-1
sfire	equ	pfire+pfire_length-1
smsaucer	equ	sfire+sfire_length-1
lgsaucer	equ	smsaucer+smsaucer_length-1
thrust	equ	lgsaucer+lgsaucer_length-1
extraship	equ	thrust+thrust_length-1

state_rom	equ	extraship+extra_length-1
;
