{$I-}
PROGRAM hextoasm;

USES
  DOS;

VAR
  buffer  : ARRAY [0..16383] OF BYTE;
  inf     : FILE;
  outf    : TEXT;
  on,asm  : STRING;
  numread,
  loop    : WORD;
  bit,chars_per_line     : BYTE;

PROCEDURE dohex;
VAR
  hl,hh : BYTE;
  BEGIN
    IF on <> '' THEN on := on + ',';
    on := on + '0';
    hl := bit AND 15;
    hh := (bit AND 240) SHR 4;
    hh := hh + ORD ('0');
    hl := hl + ORD ('0');
    IF hh > ORD ('9') THEN hh := hh + 7;
    IF hl > ORD ('9') THEN hl := hl + 7;
    on := on + CHR (hh)+CHR (hl)+'h';
    inc (chars_per_line)
  END;

BEGIN
  IF PARAMCOUNT <> 2 THEN
    BEGIN
      WRITELN (#13,#10,'Use:  HEXTOASM infile outfile');
      HALT (1)
    END;
  ASSIGN  (inf,PARAMSTR (1));
  RESET   (inf,1);
  IF IOresult <> 0 THEN
    BEGIN
      WRITELN (#13,#10,'Error opening input file.');
      HALT (1)
    END;
  ASSIGN (outf,PARAMSTR (2));
  REWRITE (outf);
  IF IOresult <> 0 THEN
    BEGIN
      WRITELN (#13,#10,'Error creating output file.');
      HALT (1)
    END;
  on := '';
  chars_per_line := 0;
  REPEAT
   BLOCKREAD (inf,buffer,16384,numread);
   loop := 0;
   WHILE loop < numread DO
     BEGIN
       bit := buffer [loop];
       dohex;
       IF chars_per_line = 10 THEN
         BEGIN
           WRITELN (outf,#9+'db'+#9+on);
           on := '';
           chars_per_line := 0
         END;
       INC (loop)
     END;
  UNTIL numread = 0;
  IF on <> '' THEN WRITELN (outf,#9+'db'+#9+on);
  CLOSE (inf);
  CLOSE (outf);
  WRITELN (#13,#10,'HEXTOASM, Finished.')
END.
