{$I-}
PROGRAM paktoasm;

USES
  DOS;

VAR
  buffer  : ARRAY [0..16383] OF BYTE;
  inf     : FILE;
  outf    : TEXT;
  on,asm  : STRING;
  numread,
  loop    : WORD;
  bit,
  temp,
  scramble : BYTE;
  any_first: BOOLEAN;

PROCEDURE dohex;
VAR
  hl,hh : BYTE;
  BEGIN
    IF on <> '' THEN on := on + ',';
    hl := bit AND 15;
    hh := (bit AND 240) SHR 4;
    hh := hh + ORD ('0');
    hl := hl + ORD ('0');
    IF hh > ORD ('9') THEN hh := hh + 7;
    IF hl > ORD ('9') THEN hl := hl + 7;
    IF hh > ORD ('9') THEN on := on + '0';
    on := on + CHR (hh)+CHR (hl)+'h'
  END;

BEGIN
  IF PARAMCOUNT <> 2 THEN
    BEGIN
      WRITELN (#13,#10,'Use: PACKED infile outfile');
      HALT (1)
    END;
  ASSIGN  (inf,PARAMSTR (1));
  RESET   (inf,1);
  IF IOresult <> 0 THEN
    BEGIN
      WRITELN (#13,#10,'Error opening input file.');
      HALT (1)
    END;
  ASSIGN (outf,PARAMSTR (2));
  REWRITE (outf);
  IF IOresult <> 0 THEN
    BEGIN
      WRITELN (#13,#10,'Error creating output file.');
      HALT (1)
    END;
  on        := '';
  any_first := false;
  REPEAT
   BLOCKREAD (inf,buffer,16384,numread);
   loop := 0;
   WHILE loop < numread DO
     BEGIN
       bit := buffer [loop];
       case char (bit) of
         'A'..'Z' : bit := bit - 64;
         'a'..'z' : bit := bit - 70;
         '0'..'9' : bit := bit + 5;
         ','      : bit := 63;
         '.'      : bit := 64;
         ' '      : bit := 76;
         '@'      : bit := 65;
         '-'      : bit := 77;
         '!'      : bit := 68;
         '"'      : bit := 69;
         ''      : bit := 70;
         '$'      : bit := 71;
         '%'      : bit := 72;
         '^'      : bit := 73;
         '&'      : bit := 74;
         '*'      : bit := 75
       end;
       IF NOT any_first THEN
         BEGIN
           scramble  := bit;
           any_first := TRUE
         END
        ELSE
         BEGIN
           temp := bit;
           bit := bit XOR scramble;
           scramble := temp
         END;
       dohex;
       IF LENGTH (on) >= 39 THEN
        BEGIN
         WRITELN (outf,#9+'db'+#9+on);
         on := ''
        END;
     INC (loop)
   END
  UNTIL numread = 0;
  bit := 0;
  bit := bit XOR scramble;
  dohex;
  IF on <> '' THEN WRITELN (outf,#9+'db'+#9+on);
  CLOSE (inf);
  CLOSE (outf);
  WRITELN (#13,#10,'PACKED, Finished.')
END.
